_B='[red]Error:[/red] '
_A=True
import functools,logging,os,sys
from typing import Any,Callable,Optional
import click
from localstack import config
from localstack.cli import LocalstackCli,LocalstackCliPlugin,console
from localstack.utils.analytics.cli import publish_invocation
from localstack_ext.bootstrap.licensing import is_logged_in
from.auth import auth
from.aws import aws
from.cli import RequiresLicenseGroup
from.cloud_pods import get_pods_community_commands,pod
from.extensions import extensions
from.iam import iam
from.license import license
from.state import state
class ProCliPlugins(LocalstackCliPlugin):
	name='pro'
	def attach(B,cli):
		A=cli.group;A.add_command(cmd_login);A.add_command(cmd_logout);A.add_command(daemons);A.add_command(dns);A.add_command(aws);A.add_command(extensions);A.add_command(license);A.add_command(state);A.add_command(auth)
		if is_logged_in():A.add_command(pod)
		else:A.add_command(get_pods_community_commands())
@click.command(name='login',short_help='Login to the LocalStack Platform',help='Login to your LocalStack account (Deprecated: please use `localstack auth login` instead)',deprecated=_A)
@click.pass_context
@click.option('-u','--username',help='Username for login',metavar='USER')
@click.option('-p','--password',help='Password for login',metavar='PWD')
@click.option('-s','--password-stdin',help='Read password from stdin',is_flag=_A,default=False)
@publish_invocation
def cmd_login(ctx,username,password,password_stdin):
	B=username;A=password;from localstack_ext.cli.auth import login
	if password_stdin:A=sys.stdin.read().strip()
	if A and not B:raise click.ClickException('Missing username')
	ctx.invoke(login,username=B,password=A)
@click.command(name='logout',short_help='Log out from the LocalStack Platform',help='Log out from the LocalStack Platform (Deprecated: please use `localstack auth logout` instead)',deprecated=_A)
@click.pass_context
@publish_invocation
def cmd_logout(ctx):from localstack_ext.cli.auth import logout as A;ctx.invoke(A)
def _handle_deprecated_daemons(func):
	@functools.wraps(func)
	def A(*A,**B):
		click.utils.echo(click.style('DeprecationWarning: The LocalStack local daemons are planned to be removed in the future, please let us know if you are actively using them.',fg='red'),err=_A)
		try:return func(*A,**B)
		except ImportError:
			if config.DEBUG:console.print_exception()
			raise click.ClickException('It appears you have a light install of localstack which does not support the local daemon processes.\nIf you would like to use local daemon processes, please reinstall localstack with Python using `pip install localstack[runtime]` instead.')
	return A
@click.group(name='daemons',short_help='Manage local daemon processes',help='\n    Manage local daemon processes.\n\n    Provides commands to manage local daemon processes which are used for certain (deprecated) LocalStack\n    features. The LocalStack local daemons are planned to be removed in the future, please let us know if you are\n    actively using them.\n    ',deprecated=_A,cls=RequiresLicenseGroup)
def daemons():0
@daemons.command(name='start',short_help='Start local daemon processes',help='\n    Start LocalStack local daemon processes.\n\n    This command starts the (deprecated) LocalStack local daemons which are used by LocalStack for\n    certain (deprecated) features. The LocalStack local daemons are planned to be removed in the\n    future, please let us know if you are actively using them.\n    ',deprecated=_A)
@publish_invocation
@_handle_deprecated_daemons
def cmd_daemons_start():from localstack_ext.bootstrap import local_daemon as A;console.print('Starting local daemons processes ...');B=A.start_in_background();B.join()
@daemons.command(name='stop',short_help='Stop local daemon processes',help='\n    Stop LocalStack local daemon processes.\n\n    This command stops all previously started (deprecated) LocalStack local daemons. The LocalStack\n    local daemons are planned to be removed in the future, please let us know if you are actively\n    using them.\n    ',deprecated=_A)
@publish_invocation
@_handle_deprecated_daemons
def cmd_daemons_stop():from localstack_ext.bootstrap import local_daemon as A;console.print('Stopping local daemons processes ...');A.kill_servers()
@daemons.command(name='log',short_help='Show log of daemon process',help='\n    Show log output of LocalStack local daemon processes.\n\n    This command shows the log output of the LocalStack local daemon. The LocalStack local daemons are\n    planned to be removed in the future, please let us know if you are actively using them.\n    ',deprecated=_A)
@publish_invocation
@_handle_deprecated_daemons
def cmd_daemons_log():
	from localstack_ext.bootstrap import local_daemon as B;A=B.get_log_file_path()
	if not os.path.isfile(A):console.print('no log found')
	else:
		with open(A,'r')as C:
			for D in C:sys.stdout.write(D);sys.stdout.flush()
@click.group(name='dns',short_help='Manage LocalStack DNS host config',help='\n    Manage the usage of the LocalStack DNS on your host.\n\n    This command provides tools to configure your the DNS on your host machine to use the LocalStack DNS\n    on your host machine.\n    The LocalStack DNS is used for certain Pro features (like the transparent endpoint injection).\n\n    \x08\n    Visit https://docs.localstack.cloud/user-guide/tools/transparent-endpoint-injection/dns-server/\n    for more information on the LocalStack DNS and how it is used.\n    ',cls=RequiresLicenseGroup)
def dns():0
@dns.command(name='systemd-resolved',short_help='Manage LocalStack DNS in systemd-resolved',help='\n        Manage the LocalStack DNS configuration using systemd-resolved (Ubuntu, Debian, etc.).\n\n        This command sets (or reverts) the LocalStack DNS, running in the current LocalStack runtime, in\n        systemd-resolved for the docker network interface.\n        Most current Linux systems - like Ubuntu, Debian, or Fedora - use systemd-resolved for the network name\n        resolution.\n    ')
@click.option('--set/--revert','-s/-r','set_',default=_A,help='Set or revert DNS settings')
@publish_invocation
def cmd_dns_systemd(set_):import localstack_ext.bootstrap.dns_utils;from localstack_ext.bootstrap.dns_utils import configure_systemd as A;console.print('Configuring systemd-resolved...');B=localstack_ext.bootstrap.dns_utils.LOG.name;localstack_ext.bootstrap.dns_utils.LOG=ConsoleLogger(B);A(not set_)
class ConsoleLogger(logging.Logger):
	def __init__(A,name):super(ConsoleLogger,A).__init__(name)
	def info(B,msg,*A,**C):console.print(msg%A)
	def warning(B,msg,*A,**C):console.print('[red]Warning:[/red] ',msg%A)
	def error(B,msg,*A,**C):console.print(_B,msg%A)
	def exception(B,msg,*A,**C):console.print(_B,msg%A);console.print_exception()